Loading...
Searching...
No Matches
dolfin::IntervalCell Class Reference

This class implements functionality for interval cell meshes. More...

`#include <IntervalCell.h>`

Inheritance diagram for dolfin::IntervalCell:
[legend]
Collaboration diagram for dolfin::IntervalCell:
[legend]

## Public Member Functions

| IntervalCell ()
| Specify cell type and facet type.
bool | is_simplex () const
| Check if cell is a simplex.
std::size_t | dim () const
| Return topological dimension of cell.
std::size_t | num_entities (std::size_t dim) const
| Return number of entities of given topological dimension.
std::size_t | num_vertices (std::size_t dim) const
std::size_t | orientation (const Cell &cell) const
| Return orientation of the cell (assuming flat space).
void | create_entities (boost::multi_array< unsigned int, 2 > &e, std::size_t dim, const unsigned int *v) const
| Create entities e of given topological dimension from vertices v.
double | volume (const MeshEntity &interval) const
| Compute (generalized) volume (length) of interval.
double | circumradius (const MeshEntity &interval) const
| Compute circumradius of interval.
double | squared_distance (const Cell &cell, const Point &point) const
| Compute squared distance to given point (3D enabled).
double | normal (const Cell &cell, std::size_t facet, std::size_t i) const
Point | normal (const Cell &cell, std::size_t facet) const
| Compute of given facet with respect to the cell.
Point | cell_normal (const Cell &cell) const
| Compute normal to given cell (viewed as embedded in 2D).
double | facet_area (const Cell &cell, std::size_t facet) const
| Compute the area/length of given facet with respect to the cell.
void | order (Cell &cell, const std::vector< std::int64_t > &local_to_global_vertex_indices) const
| Order entities locally.
virtual bool | collides (const Cell &cell, const Point &point) const
| Check whether given point collides with cell.
virtual bool | collides (const Cell &cell, const MeshEntity &entity) const
| Check whether given entity collides with cell.
std::string | description (bool plural) const
| Return description of cell type.
std::vector< std::int8_t > | vtk_mapping () const
| Mapping of DOLFIN/UFC vertex ordering to VTK/XDMF ordering.
Public Member Functions inherited from dolfin::CellType
| CellType (Type cell_type, Type facet_type)
| Constructor.
virtual | ~CellType ()
| Destructor.
Type | cell_type () const
| Return type of cell.
Type | facet_type () const
| Return type of cell for facets.
Type | entity_type (std::size_t i) const
| Return type of cell for entity of dimension i.
std::size_t | num_vertices () const
| Return number of vertices for cell.
std::size_t | orientation (const Cell &cell, const Point &up) const
| Return orientation of the cell relative to given up direction.
virtual double | h (const MeshEntity &entity) const
| Compute greatest distance between any two vertices.
virtual double | inradius (const Cell &cell) const
| Compute inradius of cell.
virtual double | radius_ratio (const Cell &cell) const
| Compute dim*inradius/circumradius for given cell.
bool | ordered (const Cell &cell, const std::vector< std::int64_t > &local_to_global_vertex_indices) const
| Check if entities are ordered.

## Static Public Member Functions

static double | squared_distance (const Point &point, const Point &a, const Point &b)
Static Public Member Functions inherited from dolfin::CellType
static CellType * | create (Type type)
| Create cell type from type (factory function).
static CellType * | create (std::string type)
| Create cell type from string (factory function).
static Type | string2type (std::string type)
| Convert from string to cell type.
static std::string | type2string (Type type)
| Convert from cell type to string.

## Additional Inherited Members

Public Types inherited from dolfin::CellType
enum class | Type : int { point , interval , triangle , quadrilateral , tetrahedron , hexahedron }
| Enum for different cell types.
Static Protected Member Functions inherited from dolfin::CellType
static void | sort_entities (std::size_t num_vertices, unsigned int *vertices, const std::vector< std::int64_t > &local_to_global_vertex_indices)
| Sort vertices based on global entity indices.
Protected Attributes inherited from dolfin::CellType
Type | _cell_type
Type | _facet_type

## Detailed Description

This class implements functionality for interval cell meshes.

## Member Function Documentation

## cell_normal()

Point IntervalCell::cell_normal | ( | const Cell & | cell | ) | const

virtual

Compute normal to given cell (viewed as embedded in 2D).

Implements dolfin::CellType.

## circumradius()

double IntervalCell::circumradius | ( | const MeshEntity & | interval | ) | const

virtual

Compute circumradius of interval.

Implements dolfin::CellType.

## collides() [1/2]

bool IntervalCell::collides | ( | const Cell & | cell,
|  | const MeshEntity & | entity ) const

virtual

Check whether given entity collides with cell.

Implements dolfin::CellType.

## collides() [2/2]

bool IntervalCell::collides | ( | const Cell & | cell,
|  | const Point & | point ) const

virtual

Check whether given point collides with cell.

Implements dolfin::CellType.

## create_entities()

void IntervalCell::create_entities | ( | boost::multi_array< unsigned int, 2 > & | e,
|  | std::size_t | dim,
|  | const unsigned int * | v ) const

virtual

Create entities e of given topological dimension from vertices v.

Implements dolfin::CellType.

## description()

std::string IntervalCell::description | ( | bool | plural | ) | const

virtual

Return description of cell type.

Implements dolfin::CellType.

## dim()

std::size_t IntervalCell::dim | ( |  | ) | const

virtual

Return topological dimension of cell.

Implements dolfin::CellType.

## facet_area()

double IntervalCell::facet_area | ( | const Cell & | cell,
|  | std::size_t | facet ) const

virtual

Compute the area/length of given facet with respect to the cell.

Implements dolfin::CellType.

## is_simplex()

bool dolfin::IntervalCell::is_simplex | ( |  | ) | const

inline virtual

Check if cell is a simplex.

Implements dolfin::CellType.

## normal() [1/2]

Point IntervalCell::normal | ( | const Cell & | cell,
|  | std::size_t | facet ) const

virtual

Compute of given facet with respect to the cell.

Implements dolfin::CellType.

## normal() [2/2]

double IntervalCell::normal | ( | const Cell & | cell,
|  | std::size_t | facet,
|  | std::size_t | i ) const

virtual

Compute component i of normal of given facet with respect to the cell

Implements dolfin::CellType.

## num_entities()

std::size_t IntervalCell::num_entities | ( | std::size_t | dim | ) | const

virtual

Return number of entities of given topological dimension.

Implements dolfin::CellType.

## num_vertices()

std::size_t IntervalCell::num_vertices | ( | std::size_t | dim | ) | const

virtual

Return number of vertices for entity of given topological dimension

Implements dolfin::CellType.

## order()

void IntervalCell::order | ( | Cell & | cell,
|  | const std::vector< std::int64_t > & | local_to_global_vertex_indices ) const

virtual

Order entities locally.

Implements dolfin::CellType.

## orientation()

std::size_t IntervalCell::orientation | ( | const Cell & | cell | ) | const

virtual

Return orientation of the cell (assuming flat space).

Implements dolfin::CellType.

## squared_distance() [1/2]

double IntervalCell::squared_distance | ( | const Cell & | cell,
|  | const Point & | point ) const

virtual

Compute squared distance to given point (3D enabled).

Implements dolfin::CellType.

## squared_distance() [2/2]

double IntervalCell::squared_distance | ( | const Point & | point,
|  | const Point & | a,
|  | const Point & | b )

static

Compute squared distance to given point. This version takes the two vertex coordinates as 3D points. This makes it possible to reuse this function for computing the (squared) distance to a triangle.

## volume()

double IntervalCell::volume | ( | const MeshEntity & | interval | ) | const

virtual

Compute (generalized) volume (length) of interval.

Implements dolfin::CellType.

## vtk_mapping()

std::vector< std::int8_t > dolfin::IntervalCell::vtk_mapping | ( |  | ) | const

inline virtual

Mapping of DOLFIN/UFC vertex ordering to VTK/XDMF ordering.

Implements dolfin::CellType.

The documentation for this class was generated from the following files:

- /build/dolfin-wwk1CC/dolfin-2019.2.0~legacy20240219.1c52e83/dolfin/mesh/IntervalCell.h
- /build/dolfin-wwk1CC/dolfin-2019.2.0~legacy20240219.1c52e83/dolfin/mesh/IntervalCell.cpp